#pragma once

#include <QWebSocket>
#include <QThread>
#include <QObject>
#include <QDebug>
#include <QUrl>
#include <QString>

class WebSocketClient: public QThread {
    Q_OBJECT

    QScopedPointer<QWebSocket> _ws;

    virtual void run() override {
        qDebug() << "Run client socket in thread...";

        _ws.reset(new QWebSocket());
        _ws->moveToThread(this);

        _ws->open(QUrl("ws://localhost:2525"));

        QObject::connect(_ws.data(), &QWebSocket::textMessageReceived
                         , [&](const QString &message) {
            qDebug() << "Client side received a text message. Lenght is" << message.length();
        }
        );

        exec();
    }

public:
    WebSocketClient(QObject *parent = nullptr)
        :QThread(parent) {
    }

};

